<template>
  <div id="app">

    <nav>
      <div class="nav-wrapper blue darken-1">
        <a href="#" class="brand-logo center">Histórico de Lançamentos</a>
      </div>
    </nav>

    <div class="container">

      <ul>
          <li v-for="(erro, index) of errors" :key="index"> 
              campo <b> {{ erro.field }} - {{ erro.defaultMessage }} </b>
          </li>
      </ul>

      <form @submit.prevent="salvar">

          <label>Descrição</label>
          <input type="text" placeholder="Descrição" v-model="lancamento.descricao">

          <label>Valor</label>
          <input type="text" placeholder="Valor" v-model="lancamento.valor">

          <label>Tipo</label>
          <input type="text" placeholder="Tipo" v-model="lancamento.tipoDescricao">

          <button class="waves-effect waves-light btn-small">Salvar<i class="material-icons left">save</i></button>

      </form>

      <table>

        <thead>

          <tr>
            <th>DESCRIÇÃO</th>
            <th>VALOR</th>
            <th>TIPO</th>
            <th>USUÁRIO</th>
          </tr>

        </thead>

        <tbody>

          <tr v-for="lancamento of lancamentos" :key="lancamento.id">

            <td> {{ lancamento.descricao }} </td>
            <td> {{ lancamento.valor }} </td>
            <td> {{ lancamento.tipo.descricao }} </td>
            <td> {{ lancamento.usuario.nome }} {{ lancamento.usuario.sobrenome }}</td>
            <td>
              <button  @click="editar(lancamento)" class="waves-effect btn-small blue darken-1"><i class="material-icons">create</i></button>
              <button  @click="remover(lancamento)" class="waves-effect btn-small red darken-1"><i class="material-icons">delete_sweep</i></button>
            </td>

          </tr>

        </tbody>
      
      </table>

    </div>

  </div>
</template>

<script>

import Lancamento from '../service/lancamentos';

export default {

  data(){
    return {
      lancamento: {
        id: '',
        descricao: '',
        valor: '',
        tipoDescricao: ''
      },

      lancamentos: [],
      errors: []
    }
  },

  mounted(){
    Lancamento.listar().then(resposta => {
      this.listar()
    })
  },

  methods: {
    listar() {
      Lancamento.listar().then(resposta => {
        this.lancamentos = resposta.data
      })
    },

    salvar () {
      if(!this.lancamento.id){
        Lancamento.salvar(this.lancamento).then(resposta => {
          this.lancamento = {}
          alert('Lançamento cadastrado com sucesso!')
          this.listar()
          this.errors = []
        }).catch(e => {
          this.errors = e.response.data.errors
      })
    }else{
      Lancamento.atualizar(this.lancamento).then(resposta => {
          this.lancamento = {}
          alert('Lançamento atualizado com sucesso!')
          this.listar()
          this.errors = []
        }).catch(e => {
          this.errors = e.response.data.errors
      })
    }

  },

  editar(lancamento){
    this.lancamento = lancamento
  },

  remover(lancamento){
    if(confirm('Deseja excluir esse lançamento?')){
      Lancamento.apagar(lancamento).then(resposta => {
        this.listar();
        this.errors = []
      }).catch(e => {
        this.errors = e.response.data.errors
      })
    }
  }
}
}


</script>